﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace WindowsFormsApplication1
{
    public partial class Form1 : Form
    {
        Random Rnd = new Random();

        double[] weight;
        String[] population;
        double[] fitness;
        Boolean run = false;

        public Form1()
        {
            InitializeComponent();
        }


        private double[] makeProblem(int n)
        {
            //generate a knapsack problem
            //at random
            double[] weight = new double[n];
            for (int i = 0; i < n; i++)
            {
                weight[i] = Rnd.NextDouble() * 50;
            }
            return weight;
        }



        private String[] makePop(int p, int n)
        {
            //make a random population of
            //n bit strings 
            //total size of population
            //is p%
            String[] pop = new String[p];
            for (int i = 0; i < p; i++)
            {
                pop[i] = makeGene(n);
            }
            return pop;
        }

        private String makeGene(int n)
        {
            //make a random n bit
            //gene in 
            StringBuilder g = new StringBuilder("");
            char c;
            for (int i = 0; i < n; i++)
            {
                c = '0';
                if (Rnd.NextDouble() > .5)
                {
                    c = '1';
                }
                g.Append(c);
            }
            int t = g.Length;
            return g.ToString();
        }

        private double[] evalPop(String[] pop, double[] w, double max, int p, int n)
        {
            //evaluate the fitness of all
            //members of the population
            double[] fit = new double[p];
            for (int i = 0; i < p; i++)
            {
                fit[i] = eval(pop[i], w, max, n);

            }
            return fit;
        }

        private double eval(String g, double[] w, double max, int n)
        {
            //return fitness of g 
            double tw = 0;
            for (int i = 0; i < n; i++)
            {

                if (g[i] == '1')
                {
                    tw = tw + w[i];
                }
            }
            double e = 0;
            double d = max - tw;
            if (d >= 0)
            {
                e = tw / max * 100;
            }
            return e;
        }




        private void breed(String[] population, double[] fitness, int p, int n)
        {
            //breed a new population
            //according to fitness
            //select breeding population
            //into breedPop
            String[] breedPop = new String[p];
            for (int i = 0; i < p; i++)
            {
                int j = select(fitness);
                breedPop[i] = population[j];
            }
     
            for (int i = 0; i < p - 1; i++)
            {
                population[i] = cross(breedPop[i].ToString(), breedPop[i + 1].ToString(), n);
            }

            population[p - 1] = cross(breedPop[0].ToString(), breedPop[p - 1].ToString(), n);

        }



        private string cross(String n1, String n2, int n)
        {

            //perform a cross on
            int c = Rnd.Next(n);
            return n1.Substring(0, c) + n2.Substring(c);
        }




        private int select(double[] fitness)
        {
            //select a population member
            // at random with a probability
            // proportional to fitness
            double totalFit = fitness.Sum();
            double r = Rnd.NextDouble() * totalFit;
            int i = 0;
            double sum = 0;
            do
            {
                sum += fitness[i];
                i++;
            }
            while (sum < r);
            return --i;
        }



        void printPopulationStats(int gen, double[] fitness)
        {
            double max = fitness.Max();
            double totalfit = fitness.Sum();
            textBox1.AppendText("Generation: " + gen.ToString());
            textBox1.AppendText(" Max Fit: " + max.ToString() + "Total Fitness:" + totalfit.ToString() + Environment.NewLine);
        }

        private void button1_Click(object sender, EventArgs e)
        {
            run = true;
            //generate a blind knapsack problem with
            //n objects, weights in w 
            double max = 250.0 + Rnd.NextDouble() * 500;
            int n = 10 + Rnd.Next(15);
            weight = makeProblem(n);
            //generate an initial population of
            //size p
            int p = 20;
            population = makePop(p, n);
            int gen = 1;
            do
            {
                fitness = evalPop(population, weight, max, p, n);

                printPopulationStats(gen, fitness);

                gen++;
                breed(population, fitness, p, n);
                Application.DoEvents();
            }
            while (run);
        }

        private void button2_Click(object sender, EventArgs e)
        {
            run = false;
        }
    }
}
